> ## Documentation Index > Fetch the complete documentation index at: https://developers.cmicglobal.com/llms.txt > Use this file to discover all available pages before exploring further. # Create a JC Job Cost Code (Job Phases) > ## Overview Cost codes are used in combination with categories (categories of cost types) to specify a job’s cost elements. For example, a cost code for electrical work can have categories for materials, labor, and equipment associated to the cost code to allow specification of the cost code’s type of cost. The JCJobCostCodes endpoint allows the create, update and query of cost codes under a specified company and job combination. ## Notes ## UI Navigation Project Controls > Job Costing > Job > Assigned Cost Codes ## Reference Article [Job Costing – Assign Cost Codes (Phases)](https://docs.cmicglobal.com/portal/Content/E_Reference_Material/JC_-_Job_Costing/Reference/Creating_a_Job/Assign_Cost_Code/Assign_Cost_Codes_Phases_Screen.htm?Highlight=assign%20cost%20codes) [Job Costing – Enter Cost Codes](https://docs.cmicglobal.com/portal/Content/E_Reference_Material/JC_-_Job_Costing/Reference/Setup/Enter_Cost_Code_Screen.htm?Highlight=assign%20cost%20codes) ## jcjobcostcodes Attributes (required) | CMiC UI Fieldname | Object | Name | Description | Type | Data Length | Example | | --- | --- | --- | --- | --- | --- | --- | | Cost Code Active Flag | jcjobcostcodes | GjjpActiveFlag | This flag identifies if the cost code is active on the system. | string | 1 | Y=Job-Phase is active;  N=Job-Phase is inactive. | | Cost Code | jcjobcostcodes | GjjpCode | This is the Cost (Phase) code. Can also be the sub-cost code. | string | 16 | 02 | | Company Code | jcjobcostcodes | GjjpCompCode | | string | 8 | 001 | | Cost Code Control Code | jcjobcostcodes | GjjpCtrlCode | This is the Controling Cost Code. The highest level of a cost code is designated the controlling cost code, which can consist of one or more sub-cost codes. The relationship between the cost code and sub-cost code is established via this code. efines the cost code hierarchy. If the cost code being entered in this line is a controlling cost code, select "All" to establish the highest level of the cost component. | string | 16 | Default – ‘ALL’, or any other alphanumeric combination. For example ‘02.100’ | | Factorable Flag | jcjobcostcodes | GjjpFactorableFlg | This checkbox is only applicable to cost codes for public sector jobs. If checked, cost code quantity factoring (forecasting based on a factor) is allowed for this cost code. Also, the job’s 'Allow Cost Code Qty Factoring' checkbox must be checked on the Settings tab of the Enter Job screen. | string | 1 | Y/N | | Job Code | jcjobcostcodes | GjjpJobCode | This is the Job Code this cost code is assigned to. Must be a valid Job Code in CMiC. | string | 10 | 15600GC | | Job Control Code | jcjobcostcodes | GjjpJobCtrlCode | This is the Control Job Code this cost code record belongs to. Must be a valid Control Job Code in CMiC. | string | 10 | ALL | | Cost Code Name | jcjobcostcodes | GjjpName | This is the name of the Cost code. | string | 50 | Masonry | | Stored Forecast Approval Flag | jcjobcostcodes | GjjpStoreFcastApprovedFlg | This is the Stored Forecast Approval Flag. When ‘Y’, the forcast is stored as approved. | string | 1 | Y/N | | Vuuid | jcjobcostcodes | GjjpVUuid | This is the unique identifier code used for the specific cost code record. | string | 64 | | ## OpenAPI ````json POST /jc-rest-api/rest/1/jcjobcostcodes { "openapi": "3.0.0", "info": { "title": "API Catalog", "description": "", "version": "1.0.0" }, "servers": [ { "url": "https://mobtest.cmiccloudr12.com/cmictestrti", "description": "CMIC API Server" } ], "security": [ { "cmicBasicAuth": [] } ], "tags": [ { "name": "Highlights" }, { "name": "Asset Management | Equipment" }, { "name": "Asset Management | Fixed Assets" }, { "name": "Asset Management | Purchase Order" }, { "name": "Asset Management | Inventory" }, { "name": "Asset Management | Requisition" }, { "name": "Asset Management | Purchase Change Order" }, { "name": "Bim Model" }, { "name": "Bim Model Revision" }, { "name": "Bim Tag Model" }, { "name": "Bim Tags" }, { "name": "Bim FileUpload Jersey" }, { "name": "Core System | Business Partners" }, { "name": "Core System | Business Partner Addresses" }, { "name": "Core System | Bank" }, { "name": "Core System | Currency" }, { "name": "Core System | Exchange Rates" }, { "name": "Core System | Global Table Text Codes" }, { "name": "Core System | Global Table Regions" }, { "name": "Core System | Terms" }, { "name": "Core System | System Contact" }, { "name": "Core System | Weight Measures" }, { "name": "Core System | Field User Defined Classifiers" }, { "name": "Core System | User Defined Classifiers by Object" }, { "name": "Core System | User Extension Definitions by Object" }, { "name": "Core System | User Extention Field Data Value" }, { "name": "Core System | User Extension Values by Object" }, { "name": "Core System | User System Role" }, { "name": "Core System | User Project Role" }, { "name": "Core System | Documents by Object" }, { "name": "Core System | Audit Status Log by Object" }, { "name": "Core System | Licensed Users" }, { "name": "Core System | Company Access" }, { "name": "Core System | Copy User Settings" }, { "name": "Core System | User Maintenance" }, { "name": "Core System | User Roles" }, { "name": "Core System | Security Groups" }, { "name": "Core System | Job/Project Security" }, { "name": "Core System | Weight Measure with Conversions Code" }, { "name": "Core System | Weight Measure Conversions Code" }, { "name": "Core System | User-defined-fields" }, { "name": "Core System | User-extension" }, { "name": "ECM and Workflow | Image Manager" }, { "name": "Financials | General Ledger" }, { "name": "Financials | Accounts Payable" }, { "name": "Financials | Accounts Receivable" }, { "name": "Preventative Maintenance | Issue Work Orders" }, { "name": "Preventative Maintenance | Issue Work Items" }, { "name": "Preventative Maintenance | Issue Work Budgets" }, { "name": "Preventative Maintenance | Issue Priorities" }, { "name": "Preventative Maintenance | Issue Status" }, { "name": "Preventative Maintenance | Issue Types" }, { "name": "Preventative Maintenance | Accumulative Equipment" }, { "name": "Preventative Maintenance | Work Orders" }, { "name": "Preventative Maintenance | Work Items" }, { "name": "Preventative Maintenance | Work Budgets" }, { "name": "Preventative Maintenance | Priorities" }, { "name": "Preventative Maintenance | Tasks" }, { "name": "HCM | UKG Pay Deductions" }, { "name": "HCM | UKG Pay Earnings" }, { "name": "HCM | UKG Pay Headers" }, { "name": "HCM | UKG Pay Taxes" }, { "name": "HCM | Payroll Geographical States" }, { "name": "HCM | Payroll Trades" }, { "name": "HCM | Payroll Union" }, { "name": "HCM | Payroll Pay Runs" }, { "name": "HCM | Payroll Pay Groups" }, { "name": "HCM | Payroll Tax" }, { "name": "HCM | Payroll Worker Compensation" }, { "name": "HCM | Payroll Work Locations" }, { "name": "HCM | Payroll Trade Pay Rates" }, { "name": "HCM | Payroll Union Pay Rates" }, { "name": "HCM | Payroll Job Pay Rates" }, { "name": "HCM | Payroll Master Benefits" }, { "name": "HCM | Payroll Master Deductions" }, { "name": "HCM | Payroll Ben/Ded/Leave Base Codes" }, { "name": "HCM | Payroll Ben/Ded Plans" }, { "name": "HCM | Payroll Ben/Ded Plan Options" }, { "name": "HCM | Payroll Company Benefits" }, { "name": "HCM | Payroll Company Deductions" }, { "name": "HCM | Payroll Vertex Geographic Locations" }, { "name": "HCM | Payroll Checks" }, { "name": "HCM | Payroll Timesheets" }, { "name": "HCM | Employee" }, { "name": "HCM | Employee (Minimum payload)" }, { "name": "HCM | Employee History" }, { "name": "HCM | Tax Exemptions" }, { "name": "HCM | Employee Tax Overrides" }, { "name": "HCM | Employee Pay Splits" }, { "name": "HCM | Employee Benefits" }, { "name": "HCM | Employee Clock In and Out" }, { "name": "HCM | Employee Deductions" }, { "name": "HCM | Employee Leaves" }, { "name": "HCM | Employee Leave History" }, { "name": "HCM | Employee Hour Types" }, { "name": "HCM | Employee Pay History" }, { "name": "HCM | Employee Work Statuses" }, { "name": "HCM | Employee Security Group" }, { "name": "HCM | Crewtime Crew" }, { "name": "HCM | Crewtime Employee Timesheet" }, { "name": "HCM | Crewtime Equipment Timesheet" }, { "name": "HCM | Crew Maintenance Activity Assignment" }, { "name": "HCM | Crew Maintenance Member Assignment" }, { "name": "HCM | Crew Maintenance Member Trade and Union Assignment" }, { "name": "HCM | Crew Maintenance Equipment Assignment" }, { "name": "HCM | Crew Maintenance Equipment Detail Assignment" }, { "name": "HCM | HR Requisitions" }, { "name": "HCM | HR Relations" }, { "name": "HCM | HR Employee Skills" }, { "name": "HCM | HR Incident" }, { "name": "HCM | HR Employee Relatives / Dependents" }, { "name": "HCM | HR Employee Positions" }, { "name": "HCM | HR Applicants" }, { "name": "HCM | HR Applications" }, { "name": "HCM | Vertex Location City" }, { "name": "HCM | HR Application History" }, { "name": "HCM | HR Dependent Benefits" }, { "name": "HCM | HR Dependent Deductions" }, { "name": "HCM | HR Employee Elected Plans" }, { "name": "HCM | HR Employee Training Certifications" }, { "name": "HCM | HR Trainings" }, { "name": "HCM | E-Timesheets" }, { "name": "HCM | System Contacts" }, { "name": "HCM | System User Payroll Security Group" }, { "name": "HCM | Payroll Timesheet Posting" }, { "name": "HCM | CrewTimesheet Posting" }, { "name": "HCM | HR Positions Master" }, { "name": "HCM | Payroll Pay Periods" }, { "name": "HCM | Payroll Rate Codes" }, { "name": "HCM | Payroll Overhead Codes and Rates" }, { "name": "HCM | Payroll Assigned Overhead to Jobs" }, { "name": "Materials Management | Material Sale Orders" }, { "name": "Materials Management | Material Sale Orders Details" }, { "name": "Materials Management | Truck Rate Detail" }, { "name": "Opportunity Management | Competitors" }, { "name": "Opportunity Management | Opportunities" }, { "name": "Opportunity Management | Revenue Details" }, { "name": "Opportunity Management | Opportunity History" }, { "name": "Opportunity Management | Organization" }, { "name": "Project Controls | Job Billing" }, { "name": "Project Controls | Job Cost" }, { "name": "Project Controls | PCI Details" }, { "name": "Project Controls | Unposted PCI Details" }, { "name": "Project Controls | PCI Headers" }, { "name": "Project Controls | Owner Change Orders" }, { "name": "Project Controls | CM Statuses" }, { "name": "Project Controls | CM Types" }, { "name": "Project Controls | CM Vendor Details" }, { "name": "Project Controls | Post PCI" }, { "name": "Project Management | Uploading Documents" }, { "name": "Project Management | Downloading Documents" }, { "name": "Project Management | Foreign Bid Item Imports" }, { "name": "Project Management | Communications" }, { "name": "Project Management | Daily Journals" }, { "name": "Project Management | Communications Types" }, { "name": "Project Management | Daily Journal Daily Work Plans" }, { "name": "Project Management | Daily Journal Field Forces" }, { "name": "Project Management | Daily Journal Labour" }, { "name": "Project Management | Daily Journal Materials" }, { "name": "Project Management | Daily Journal Owner Equipment" }, { "name": "Project Management | Daily Journal Quality Control" }, { "name": "Project Management | Daily Journal Tasks" }, { "name": "Project Management | Daily Journal Trade Equipment" }, { "name": "Project Management | Daily Journal Transactions" }, { "name": "Project Management | Daily Journal User Defined Data" }, { "name": "Project Management | Daily Journal Visitors" }, { "name": "Project Management | Daily Journal Bill Details" }, { "name": "Project Management | Field Work Directives" }, { "name": "Project Management | Contract Types" }, { "name": "Project Management | Company Contacts" }, { "name": "Project Management | Distribution BCC" }, { "name": "Project Management | Distribution CC" }, { "name": "Project Management | Field Work Directive Statuses" }, { "name": "Project Management | Issues" }, { "name": "Project Management | Key Players" }, { "name": "Project Management | Meetings" }, { "name": "Project Management | Meeting Attendees" }, { "name": "Project Management | Meeting Item Statuses" }, { "name": "Project Management | Meeting Tracks" }, { "name": "Project Management | Notes" }, { "name": "Project Management | Projects" }, { "name": "Project Management | Project Items" }, { "name": "Project Management | Project Item Phase Segment Sums" }, { "name": "Project Management | Project Partners" }, { "name": "Project Management | Notices" }, { "name": "Project Management | Notice Statuses" }, { "name": "Project Management | Owner JS Query" }, { "name": "Project Management | PCI Real Locations" }, { "name": "Project Management | Project Contacts" }, { "name": "Project Management | RFIs (Requests for Information)" }, { "name": "Project Management | RFI Statuses" }, { "name": "Project Management | Submittal Packages" }, { "name": "Project Management | Submittal Package Details" }, { "name": "Project Management | Submittal Package Status" }, { "name": "Project Management | Submittals" }, { "name": "Project Management | Submittal Status" }, { "name": "Project Management | Transmittals" }, { "name": "Project Management | Subcontract Headers" }, { "name": "Project Management | Subcontract Schedules" }, { "name": "Project Management | Subcontract Sechedule Phase Segment Sums" }, { "name": "Project Management | User Roles" }, { "name": "Project Management | Punchlists" }, { "name": "Project Management | Punchlist Details" }, { "name": "Project Management | Punchlist Statuses" }, { "name": "Project Management | Meeting Items" }, { "name": "Project Management | Self Perform Vendor" }, { "name": "Project Management | Submittal Types" }, { "name": "Project Management | Assign contact and partner to project" }, { "name": "Project Management | Subcontract Prequal" }, { "name": "Project Management | Bid Item Package" } ], "paths": { "/jc-rest-api/rest/1/jcjobcostcodes": { "post": { "tags": [ "Project Controls | Job Cost" ], "summary": "Create a JC Job Cost Code (Job Phases)", "description": "## Overview\n\nCost codes are used in combination with categories (categories of cost types) to specify a job’s cost elements. For example, a cost code for electrical work can have categories for materials, labor, and equipment associated to the cost code to allow specification of the cost code’s type of cost. The JCJobCostCodes endpoint allows the create, update and query of cost codes under a specified company and job combination.\n\n## Notes\n\n## UI Navigation\n\nProject Controls > Job Costing > Job > Assigned Cost Codes\n\n## Reference Article\n\n[Job Costing – Assign Cost Codes (Phases)](https://docs.cmicglobal.com/portal/Content/E_Reference_Material/JC_-_Job_Costing/Reference/Creating_a_Job/Assign_Cost_Code/Assign_Cost_Codes_Phases_Screen.htm?Highlight=assign%20cost%20codes)\n\n[Job Costing – Enter Cost Codes](https://docs.cmicglobal.com/portal/Content/E_Reference_Material/JC_-_Job_Costing/Reference/Setup/Enter_Cost_Code_Screen.htm?Highlight=assign%20cost%20codes)\n\n## jcjobcostcodes Attributes (required)\n\n| CMiC UI Fieldname | Object | Name | Description | Type | Data Length | Example |\n| --- | --- | --- | --- | --- | --- | --- |\n| Cost Code Active Flag | jcjobcostcodes | GjjpActiveFlag | This flag identifies if the cost code is active on the system. | string | 1 | Y=Job-Phase is active;  N=Job-Phase is inactive. |\n| Cost Code | jcjobcostcodes | GjjpCode | This is the Cost (Phase) code. Can also be the sub-cost code. | string | 16 | 02 |\n| Company Code | jcjobcostcodes | GjjpCompCode | | string | 8 | 001 |\n| Cost Code Control Code | jcjobcostcodes | GjjpCtrlCode | This is the Controling Cost Code. The highest level of a cost code is designated the controlling cost code, which can consist of one or more sub-cost codes. The relationship between the cost code and sub-cost code is established via this code. efines the cost code hierarchy. If the cost code being entered in this line is a controlling cost code, select \"All\" to establish the highest level of the cost component. | string | 16 | Default – ‘ALL’, or any other alphanumeric combination. For example ‘02.100’ |\n| Factorable Flag | jcjobcostcodes | GjjpFactorableFlg | This checkbox is only applicable to cost codes for public sector jobs. If checked, cost code quantity factoring (forecasting based on a factor) is allowed for this cost code. Also, the job’s 'Allow Cost Code Qty Factoring' checkbox must be checked on the Settings tab of the Enter Job screen. | string | 1 | Y/N |\n| Job Code | jcjobcostcodes | GjjpJobCode | This is the Job Code this cost code is assigned to. Must be a valid Job Code in CMiC. | string | 10 | 15600GC |\n| Job Control Code | jcjobcostcodes | GjjpJobCtrlCode | This is the Control Job Code this cost code record belongs to. Must be a valid Control Job Code in CMiC. | string | 10 | ALL |\n| Cost Code Name | jcjobcostcodes | GjjpName | This is the name of the Cost code. | string | 50 | Masonry |\n| Stored Forecast Approval Flag | jcjobcostcodes | GjjpStoreFcastApprovedFlg | This is the Stored Forecast Approval Flag. When ‘Y’, the forcast is stored as approved. | string | 1 | Y/N |\n| Vuuid | jcjobcostcodes | GjjpVUuid | This is the unique identifier code used for the specific cost code record. | string | 64 | |\n\n", "requestBody": { "content": { "application/json": { "schema": { "type": "object", "example": { "GjjpCompCode": "ZZ", "GjjpJobCode": "PHTEST", "GjjpCode": "01", "GjjpName": "550 name", "GjjpStoreFcastApprovedFlg": "N", "GjjpActiveFlag": "Y", "GjjpFactorableFlg": "N", "GjjpCtrlCode": "ALL", "GjjpJobCtrlCode": "ALL", "GjjpVUuid": "" } } } } }, "parameters": [ { "name": "Content-Type", "in": "header", "schema": { "type": "string" }, "example": "application/vnd.oracle.adf.resourceitem+json" } ], "responses": { "201": { "description": "Created", "headers": { "Content-Type": { "schema": { "type": "string", "example": "application/vnd.oracle.adf.resourceitem+json" } } }, "content": { "application/json": { "schema": { "type": "object" }, "example": { "GjjpActComplDate": null, "GjjpActStartDate": null, "GjjpActiveFlag": "Y", "GjjpAttachOraseq": null, "GjjpBillCode": null, "GjjpBillName": null, "GjjpBillingRateTableCode": null, "GjjpBillingTypeCode": null, "GjjpBillingUnitFlag": null, "GjjpBudgUnit": null, "GjjpChgOrdUnit": null, "GjjpClvValueCode1": null, "GjjpClvValueCode2": null, "GjjpClvValueCode3": null, "GjjpClvValueCode4": null, "GjjpClvValueCode5": null, "GjjpClvValueCode6": null, "GjjpCode": "002", "GjjpCompCode": "001", "GjjpComplUnit": null, "GjjpCreateDate": null, "GjjpCtrlCode": "00", "GjjpEbudgCostAmt": null, "GjjpEbudgRevenueAmt": null, "GjjpEqpOraseq": null, "GjjpEstComplDate": null, "GjjpEstStartDate": null, "GjjpFactor": null, "GjjpFactorableFlg": "N", "GjjpFinalProductFlag": null, "GjjpHbRecAmt": null, "GjjpHier": null, "GjjpInvoiceFormatCode": null, "GjjpItemCode": null, "GjjpItemCompCode": null, "GjjpItemTypeCode": null, "GjjpIuCreateDate": null, "GjjpIuUpdateDate": null, "GjjpJobCode": "00100", "GjjpJobCtrlCode": "ALL", "GjjpMaxBillingAmt": null, "GjjpMaxBillingBudgetAmt": null, "GjjpName": "Drawings", "GjjpObudgCostAmt": null, "GjjpObudgRevenueAmt": null, "GjjpObudgUnit": null, "GjjpPhsTypeCode": null, "GjjpPriorComplUnit": null, "GjjpProjQty": null, "GjjpProjThresholdPct": null, "GjjpQraOverrideIndicator": null, "GjjpRecAmt": null, "GjjpSingleCatBudgFlag": null, "GjjpStatusCode": null, "GjjpStoreFcastApprovedFlg": "N", "GjjpUeValidFlag": null, "GjjpUnitFcastAttachOraseq": null, "GjjpUserEnteredProjQty": null, "GjjpWmCode": null, "GjjpVUuid": "03210A6E8A8A6B82E06316821FACF1C1", "links": [ { "rel": "self", "href": "http://mobtest.cmiccloudr12.com:80/cmictestrti/jc-rest-api/rest/1/jcjobcostcodes/03210A6E8A8A6B82E06316821FACF1C1", "name": "jcjobcostcodes", "kind": "item" }, { "rel": "canonical", "href": "http://mobtest.cmiccloudr12.com:80/cmictestrti/jc-rest-api/rest/1/jcjobcostcodes/03210A6E8A8A6B82E06316821FACF1C1", "name": "jcjobcostcodes", "kind": "item" } ] } } } } } } } }, "components": { "securitySchemes": { "cmicBasicAuth": { "type": "http", "scheme": "basic", "description": "Basic authentication" } } } } ````